"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Grid = _interopRequireDefault(require("@mui/material/Grid"));

var _Box = _interopRequireDefault(require("@mui/material/Box"));

var _Checkbox = _interopRequireDefault(require("@mui/material/Checkbox"));

var _Typography = _interopRequireDefault(require("@mui/material/Typography"));

var _styles = require("@mui/styles");

var _Renderer = require("./Renderer");

var _ExpandableListItem = _interopRequireDefault(require("./ExpandableListItem"));

var _NoContent = _interopRequireDefault(require("./NoContent"));

var _Pagination = _interopRequireDefault(require("./Pagination"));

var _lodash = _interopRequireDefault(require("lodash.isequal"));

var _lodash2 = require("lodash");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  selectAllBox: {
    padding: "12px 16px"
  },
  checkbox: {
    padding: "0 10px 5px 0"
  }
};
/**
 * List with expandable items - mobile table analogue
 */

var DataList = /*#__PURE__*/function (_Component) {
  _inherits(DataList, _Component);

  var _super = _createSuper(DataList);

  function DataList(props) {
    var _this;

    _classCallCheck(this, DataList);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "handleChangePage", function (params) {
      return _this.props.onChangePage(params);
    });

    _defineProperty(_assertThisInitialized(_this), "handleSelection", function (row) {
      var onSelectionChange = _this.props.onSelectionChange;
      var selection = _this.state.selection;
      var newSelection = (0, _lodash2.cloneDeep)(selection);

      if (newSelection.indexOf(row.id) === -1) {
        newSelection.push(row.id);
      } else {
        newSelection.splice(newSelection.indexOf(row.id), 1);
      }

      _this.setState({
        selection: newSelection
      });

      onSelectionChange({
        rowIds: newSelection
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleSelectAll", function () {
      var _this$props = _this.props,
          onSelectionChange = _this$props.onSelectionChange,
          data = _this$props.data,
          rowsPerPage = _this$props.rowsPerPage;
      var selection = _this.state.selection;
      var newSelection = (0, _lodash2.cloneDeep)(selection);

      if (newSelection.length > 0) {
        newSelection = [];
      } else {
        newSelection = data.map(function (row) {
          return row.id;
        });
      }

      _this.setState({
        selection: newSelection
      });

      onSelectionChange({
        rowIds: newSelection
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getRowClass", function (index) {
      var rowsClassArray = _this.props.rowsClassArray;
      return rowsClassArray && rowsClassArray[index] ? rowsClassArray[index] : "";
    });

    _defineProperty(_assertThisInitialized(_this), "createListItemTitle", function (columns, row, data) {
      var primaryColumns = columns.filter(function (column) {
        return column.primary;
      });
      return primaryColumns.length === 0 ? /*#__PURE__*/_react["default"].createElement(_Renderer.CellRenderer, {
        column: columns[0],
        row: row,
        data: data
      }) : primaryColumns.map(function (column) {
        return /*#__PURE__*/_react["default"].createElement(_Renderer.CellRenderer, {
          key: column.field,
          column: column,
          row: row,
          data: data
        });
      }).reduce(function (prev, next) {
        return [prev, " ", next];
      }); // divide item headers by space
    });

    _defineProperty(_assertThisInitialized(_this), "createListItemDescription", function (columns, row, data, excludePrimary) {
      return /*#__PURE__*/_react["default"].createElement("div", null, columns.filter(function (column) {
        return !excludePrimary || !column.primary;
      }).map(function (column, index) {
        return /*#__PURE__*/_react["default"].createElement(_Grid["default"], {
          key: "".concat(column.headerName, "-").concat(index),
          container: true
        }, /*#__PURE__*/_react["default"].createElement(_Grid["default"], {
          item: true,
          xs: true
        }, /*#__PURE__*/_react["default"].createElement(_Renderer.LabelRenderer, {
          column: column,
          data: data
        })), /*#__PURE__*/_react["default"].createElement(_Grid["default"], {
          item: true,
          xs: true
        }, /*#__PURE__*/_react["default"].createElement(_Renderer.CellRenderer, {
          column: column,
          row: row,
          data: data
        })));
      }));
    });

    _this.state = {
      selection: []
    };
    return _this;
  }

  _createClass(DataList, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      var _this$props2 = this.props,
          enableShouldComponentUpdate = _this$props2.enableShouldComponentUpdate,
          data = _this$props2.data;

      if (enableShouldComponentUpdate) {
        return !(0, _lodash["default"])(nextProps.data, data);
      }

      return true;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          classes = _this$props3.classes,
          columns = _this$props3.columns,
          count = _this$props3.count,
          checkboxSelection = _this$props3.checkboxSelection,
          data = _this$props3.data,
          excludePrimaryFromDetails = _this$props3.excludePrimaryFromDetails,
          noContentText = _this$props3.noContentText,
          page = _this$props3.page,
          rowsPerPage = _this$props3.rowsPerPage,
          scrollToSelected = _this$props3.scrollToSelected,
          scrollOptions = _this$props3.scrollOptions,
          showPagination = _this$props3.showPagination,
          ExpansionPanelDetailsProps = _this$props3.ExpansionPanelDetailsProps,
          ExpansionPanelDetailsTypographyProps = _this$props3.ExpansionPanelDetailsTypographyProps,
          ExpansionPanelMoreIconProps = _this$props3.ExpansionPanelMoreIconProps,
          ExpansionPanelProps = _this$props3.ExpansionPanelProps,
          ExpansionPanelSummaryProps = _this$props3.ExpansionPanelSummaryProps,
          ExpansionPanelSummaryTypographyProps = _this$props3.ExpansionPanelSummaryTypographyProps,
          SelectedExpansionPanelProps = _this$props3.SelectedExpansionPanelProps,
          TablePaginationProps = _this$props3.TablePaginationProps;
      var selection = this.state.selection;

      if (!Array.isArray(data) || data.length === 0 || !Array.isArray(columns) || columns.length === 0) {
        return /*#__PURE__*/_react["default"].createElement(_NoContent["default"], {
          text: noContentText
        });
      }

      return /*#__PURE__*/_react["default"].createElement("div", null, checkboxSelection && /*#__PURE__*/_react["default"].createElement(_Box["default"], {
        className: classes.selectAllBox
      }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
        className: classes.checkbox,
        checked: selection.length,
        indeterminate: selection.length > 0,
        onClick: this.handleSelectAll
      }), /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
        component: "span"
      }, "Select All")), data.slice(page * rowsPerPage, page * rowsPerPage + rowsPerPage).map(function (row, index) {
        return /*#__PURE__*/_react["default"].createElement(_ExpandableListItem["default"], {
          key: index,
          onSelect: _this2.handleSelection,
          panelClass: _this2.getRowClass(index),
          summary: _this2.createListItemTitle(columns, row, data),
          row: row,
          details: _this2.createListItemDescription(columns, row, data, excludePrimaryFromDetails),
          checkboxSelection: checkboxSelection,
          selected: selection.indexOf(row.id) !== -1,
          scrollToSelected: scrollToSelected,
          scrollOptions: scrollOptions,
          ExpansionPanelDetailsProps: ExpansionPanelDetailsProps,
          ExpansionPanelDetailsTypographyProps: ExpansionPanelDetailsTypographyProps,
          ExpansionPanelMoreIconProps: ExpansionPanelMoreIconProps,
          ExpansionPanelProps: ExpansionPanelProps,
          ExpansionPanelSummaryProps: ExpansionPanelSummaryProps,
          ExpansionPanelSummaryTypographyProps: ExpansionPanelSummaryTypographyProps,
          SelectedExpansionPanelProps: SelectedExpansionPanelProps
        });
      }), showPagination && /*#__PURE__*/_react["default"].createElement(_Pagination["default"], {
        component: "div",
        count: count,
        rowsPerPage: rowsPerPage,
        page: page,
        TablePaginationProps: TablePaginationProps,
        onChangePage: this.handleChangePage
      }));
    }
  }]);

  return DataList;
}(_react.Component);

var _default = (0, _styles.withStyles)(styles)(DataList);

exports["default"] = _default;